// Generated by CoffeeScript 1.7.0
(function() {
  var W, detect, detect_file, fs, nodefn, os, path, read, readFile, readdir, yaml, _;

  fs = require('fs');

  path = require('path');

  W = require('when');

  nodefn = require('when/node');

  os = require('os');

  yaml = require('js-yaml');

  _ = require('lodash');


  /**
   * Read the first three bytes of each file, if they are '---', assume
   * that we're working with dynamic content.
   *
   * @private
   *
   * @param  {File} file - vinyl-wrapped file instance
   * @return {Boolean} promise returning true or false
   */

  detect = function(str) {
    if (str.split(os.EOL.substring(0, 1))[0] === '---') {
      return true;
    } else {
      return false;
    }
  };

  detect_file = function(path) {
    var deferred, res;
    deferred = W.defer();
    res = false;
    fs.createReadStream(path, {
      encoding: 'utf-8',
      start: 0,
      end: 3
    }).on('error', deferred.reject).on('end', function() {
      return deferred.resolve(res);
    }).on('data', function(data) {
      if (detect(data)) {
        return res = true;
      }
    });
    return deferred.promise;
  };

  read = function(str) {
    var br, data, front_matter_str, regex;
    if (!detect(str)) {
      return false;
    }
    br = "\\" + os.EOL;
    regex = new RegExp(RegExp("^---\\s*" + br + "([\\s\\S]*?)" + br + "?---\\s*" + br + "?"));
    front_matter_str = str.match(regex);
    data = yaml.safeLoad(front_matter_str[1]);
    data.content = str.replace(front_matter_str[0], '');
    return data;
  };

  readFile = function(path) {
    return nodefn.call(fs.stat, path).then(function(res) {
      if (res.isDirectory()) {
        return false;
      }
      return detect_file(path).then(function(res) {
        if (!res) {
          return false;
        }
        return nodefn.call(fs.readFile, path, 'utf8').then(read);
      });
    });
  };

  readdir = function(dir) {
    return nodefn.call(fs.readdir, dir).then(function(paths) {
      return W.map(paths, function(p) {
        return readFile(path.join(dir, p));
      });
    }).then(_.compact);
  };

  module.exports = {
    read: read,
    readFile: readFile,
    readdir: readdir,
    detect_file: detect_file
  };

}).call(this);
